#include "TVPPlugIn.h"
#include "TPPropGetIF.h"

// for vsnwprintf
#include <stdio.h>



//---------------------------------------------------------------------------
ttstr & GetErrorMessageStr(DWORD err)
{
	static ttstr msg;
	LPVOID lpMsgBuf;

	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL, err, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, 0, NULL);

	msg = (char *)lpMsgBuf;

	// obt@B
	LocalFree(lpMsgBuf);

	return msg;
}
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Array Util.
//------------------------------------------------------------------------------
// create Array
//------------------------------------------------------------------------------
void TPCreateObject_Array(tTJSVariant * result)
{
	TVPExecuteExpression(TJS_W("new Array();"), result);
}

//------------------------------------------------------------------------------
// property get Array.count
//------------------------------------------------------------------------------
tjs_int TPPropGet_Array_count(iTJSDispatch2 * obj, const tjs_char * memberName)
{
	tjs_int rv = -1;
	try {
		rv = TJSGetArrayElementCount(obj);
	} catch (...) {
		TJSE_THROW(TJSEM_E_PROPGETBYNUM_FAIL, memberName, TJS_W("Array.count"));
	}
	return rv;
}
//---------------------------------------------------------------------------
tjs_int TPPropGet_Array_count(iTJSDispatch2 * obj)
{
	return TPPropGet_Array_count(obj, TJSEM_ANON_FUNC);
}
//---------------------------------------------------------------------------
// zRs[
void TPFuncCall_Array_assign(iTJSDispatch2 * src, iTJSDispatch2 * dest)
{
	TPFuncCall_Array_assign(src, dest, TJSEM_ANON_FUNC);
}
//---------------------------------------------------------------------------
void TPFuncCall_Array_assign(iTJSDispatch2 * src, iTJSDispatch2 * dest, const tjs_char * memberName)
{
	const num_params = 1;

	static tjs_uint32 hint = 0;
	static tTJSVariant val[num_params] = { NULL };

	val[0] = src;
	tTJSVariant *pval[1] = { val };
	TP_ITJSDISPATCH2_FUNCCALL(dest, Array, assign, &hint, NULL, num_params, pval, memberName);

	return;
}
//---------------------------------------------------------------------------
// Array.erase
void TPFuncCall_Array_erase(iTJSDispatch2 * src, tjs_int idx)
{
	TPFuncCall_Array_erase(src, idx, TJSEM_ANON_FUNC);
}
//---------------------------------------------------------------------------
void TPFuncCall_Array_erase(iTJSDispatch2 * src, tjs_int idx, const tjs_char * memberName)
{
	const num_params = 1;

	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	static tTJSVariant val[num_params] = { (tjs_int64)0 };

	val[0] = (tjs_int64)idx;
	tTJSVariant *pval[1] = {val};
	TP_ITJSDISPATCH2_FUNCCALL(src, Array, erase, &hint, &result, num_params, pval, memberName)
	return;
}
//---------------------------------------------------------------------------
// Array.add
void TPFuncCall_Array_add(iTJSDispatch2 * src, tTJSVariant * obj)
{
	TPFuncCall_Array_add(src, obj, TJSEM_ANON_FUNC);
}
//---------------------------------------------------------------------------
void TPFuncCall_Array_add(iTJSDispatch2 * src, tTJSVariant * obj, const tjs_char * memberName)
{
	const num_params = 1;

	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	static tTJSVariant * val[num_params] = { NULL };

	val[0] = obj;
	TP_ITJSDISPATCH2_FUNCCALL(src, Array, add, &hint, &result, num_params, val, memberName)
	return;
}
//---------------------------------------------------------------------------
// Array.clear
void TPFuncCall_Array_clear(iTJSDispatch2 * src)
{
	TPFuncCall_Array_clear(src, TJSEM_ANON_FUNC);
}
//---------------------------------------------------------------------------
void TPFuncCall_Array_clear(iTJSDispatch2 * src, const tjs_char * memberName)
{
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	TP_ITJSDISPATCH2_FUNCCALL(src, Array, clear, &hint, &result, 0, NULL, memberName)
	return;
}
//---------------------------------------------------------------------------





// X,Y C^[[u
void Array_deinterleaveXY(iTJSDispatch2 * path, tjs_int arraysize, tjs_int * x, tjs_int * y)
{
	tTJSVariant val; // work

	for (tjs_int i = 0; i < arraysize; i++) {
		x[i] = TPPropGetByNum_Array_AsInt(path, 2*i, false);
		y[i] = TPPropGetByNum_Array_AsInt(path, 2*i+1, false);
	}
}
//---------------------------------------------------------------------------
void Array_deinterleaveXY(iTJSDispatch2 * path, tjs_int arraysize, tjs_real * x, tjs_real * y)
{
	tTJSVariant val; // work

	for (tjs_int i = 0; i < arraysize; i++) {
		x[i] = TPPropGetByNum_Array_AsReal(path, 2*i, false);
		y[i] = TPPropGetByNum_Array_AsReal(path, 2*i+1, false);
	}
}
//---------------------------------------------------------------------------
// Oo
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName)
{
	ttstr message = TVPFormatMessage(TPM_MESSAGE_HEADER TJS_W("%1: %2"), ttstr(memberName), msg);
	TVPAddLog(message);
}
//---------------------------------------------------------------------------
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName, const ttstr & param1)
{
	TP_AddLog(TVPFormatMessage(msg, param1).c_str(), memberName);
}
//---------------------------------------------------------------------------
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName, const ttstr & param1, const ttstr & param2)
{
	TP_AddLog(TVPFormatMessage(msg, param1, param2).c_str(), memberName);
}
//---------------------------------------------------------------------------
void TP_AddConstRegisterExpression(ttstr & expression, const ttstr & name, tjs_int value)
{
	expression += "global.";
	expression += name;
	expression += " = ";
	expression += ttstr(value);
	expression += ";\n";
	return;
}
//---------------------------------------------------------------------------
void TP_AddConstDeleteExpression(ttstr & expression, const ttstr & name)
{
	expression += "delete global.";
	expression += name;
	expression += ";\n";
	return;
}
//---------------------------------------------------------------------------
tTJSVariantOctet * AllocVariantOctetFromString(ttstr & workstr, tjs_int mode, const tjs_char * __tp_member_name)
{
	switch (mode) {
	case TP_DUMP_STR_LOCALE      :
	case TP_DUMP_ENDIAN_PLATFORM :
	case TP_DUMP_ENDIAN_LITTLE   :
	case TP_DUMP_ENDIAN_BIG      :
		break;
	default:
		TJSE_THROW(TPM_E_INVALID_DUMP_MODE, __tp_member_name);
	};


	tTJSVariantOctet * rv = NULL;
	bool swap = false;

	if (mode == TP_DUMP_ENDIAN_LITTLE) {
		swap = (TJS_HOST_IS_LITTLE_ENDIAN) ? false : true;
	}
	if (mode == TP_DUMP_ENDIAN_BIG) {
		swap = (TJS_HOST_IS_LITTLE_ENDIAN) ? true : false;
	}

	// ]ʂAvbgtH[̃[JɈˑϊ
	if (mode == TP_DUMP_STR_LOCALE) {
		// i[
		tjs_int narrow_len = workstr.GetNarrowStrLen();
		if (narrow_len == -1) TJSE_THROW(TJSEM_E_WIDE_TO_NARROW_FAIL, __tp_member_name);

		char * narrow_str = new char [narrow_len + 1];

		try {
			// ϊ
			workstr.ToNarrowStr(narrow_str, narrow_len);
			rv = TJSAllocVariantOctet((tjs_uint8 *)narrow_str, narrow_len);
		} catch (...) {
			delete [] narrow_str;
			throw;
		}
		delete [] narrow_str;

	} else {
		// TODO?: TQ[gyȀH
		tjs_int len = workstr.GetLen();
		const tjs_int CHARSIZE = sizeof(tjs_char);
		const tjs_int chlen = CHARSIZE * workstr.GetLen();

		if (swap && workstr.GetLen() > 0) {
			const tjs_uint8 * base = (tjs_uint8 *)(workstr.c_str());
			tjs_uint8 * ref = new tjs_uint8[chlen];
			for (tjs_int i = 0; i < len; i++) {
				for (tjs_int j = 0; j < CHARSIZE; j++) {
					ref[i * CHARSIZE + j] = base[i * CHARSIZE + (CHARSIZE - j - 1)];
				}
			}
			rv = TJSAllocVariantOctet(ref, chlen);
			delete[] ref;

		} else {
			const tjs_uint8 * ref = (tjs_uint8 *)(workstr.c_str());
			rv = TJSAllocVariantOctet(ref, chlen);
		}
	}

	return rv;

}

//---------------------------------------------------------------------------
// tjsString.cpp ̃Rs[
tjs_int __cdecl TP_vsprintf(ttstr &result, const tjs_char *format, ...)
{
	tjs_int r;
	const size_t bufsize = 8192;

	tjs_char *buf = new tjs_char [bufsize];
	try
	{
		tjs_int size = bufsize - 1; /*TJS_vsnprintf(NULL, 0, format, param);*/
		va_list param;
		va_start(param, format);
		r = vsnwprintf(buf, size, format, param);
		result.AllocBuffer(r);
		if(r)
		{
			TJS_strcpy(const_cast<tjs_char*>(result.c_str()), buf);
		}
		va_end(param);
		result.FixLen();
	}
	catch(...)
	{
		delete [] buf;
		throw;
	}
	delete [] buf;
	return r;
}

