#ifndef _TVP_PLUGIN_COMMON_H_
#define _TVP_PLUGIN_COMMON_H_

#include <windows.h>
#include "tp_stub.h"
#include "TPException.h"
#include "TPRevision.h"
#include "TPMessage.h"
#include "ZrvlVariant.h"

#define TPFUNCCALL 
#define TPFASTCALL __fastcall

#ifndef TJSE_THROW
#define TJSE_THROW TP_ThrowMes
#endif

// ϊ
#define TP_DUMP_STR_LOCALE      0	// [JɈˑϊiWindowsȂShift_JISj
#define TP_DUMP_ENDIAN_PLATFORM 1	// vbgtH[ɏ]
#define TP_DUMP_ENDIAN_LITTLE   2	// gGfBAɕϊ
#define TP_DUMP_ENDIAN_BIG      3	// rbOGfBAɕϊ




// func call
#define TP_ITJSDISPATCH2_FUNCCALL(_obj, _cls, _name, _hint, _result, _nump, _pval, _caller) \
	{ \
		tjs_error __error_code = _obj->FuncCall(0, TJS_W(#_name), _hint, _result, _nump, _pval, _obj); \
		if (TJS_FAILED(__error_code)) { \
			TJSE_THROW(TJSEM_E_FUNCCALL_FAIL, _caller, TJS_W(#_cls) TJS_W(".") TJS_W(#_name)); \
		} \
	}

// func call (closure)
#define TP_OBJECTCLOSURE_FUNCCALL(_clo, _cls, _name, _hint, _result, _nump, _pval, _caller) \
	{ \
		tjs_error __error_code = _clo->FuncCall(0, TJS_W(#_name), _hint, _result, _nump, _pval, NULL); \
		if (TJS_FAILED(__error_code)) { \
			TJSE_THROW(TJSEM_E_FUNCCALL_FAIL, _caller, TJS_W(#_cls) TJS_W(".") TJS_W(#_name)); \
		} \
	}

// get by num
#define TP_ITJSDISPATCH2_PROPGETBYNUM(_obj, _cls, _id, _pval, _caller) \
	{ \
		tjs_error __error_code = _obj->PropGetByNum(TJS_MEMBERMUSTEXIST, (_id), _pval, _obj); \
		if (TJS_FAILED(__error_code)) { \
			TJSE_THROW(TJSEM_E_PROPGETBYNUM_FAIL, _caller, TJS_W(#_cls), (ttstr)(_id)); \
		} \
	}

// get by name
#define TP_ITJSDISPATCH2_PROPGET(_obj, _cls, _name, _hint, _val, _caller) \
	{ \
		tjs_error __error_code = _obj->PropGet(TJS_MEMBERMUSTEXIST, TJS_W(#_name), _hint, _val, _obj); \
		if (TJS_FAILED(__error_code)) { \
			TJSE_THROW(TJSEM_E_PROPGETBYNUM_FAIL, _caller, TJS_W(#_cls) TJS_W(".") TJS_W(#_name)); \
		} \
	}



// Array Util.
void TPCreateObject_Array(tTJSVariant * result);
tjs_int TPPropGet_Array_count(iTJSDispatch2 * obj, const tjs_char * memberName);
tjs_int TPPropGet_Array_count(iTJSDispatch2 * obj);
void TPFuncCall_Array_assign(iTJSDispatch2 * src, iTJSDispatch2 * dest);
void TPFuncCall_Array_assign(iTJSDispatch2 * src, iTJSDispatch2 * dest, const tjs_char * memberName);
void TPFuncCall_Array_erase(iTJSDispatch2 * src, tjs_int idx);
void TPFuncCall_Array_erase(iTJSDispatch2 * src, tjs_int idx, const tjs_char * memberName);
void TPFuncCall_Array_add(iTJSDispatch2 * src, tTJSVariant * obj);
void TPFuncCall_Array_add(iTJSDispatch2 * src, tTJSVariant * obj, const tjs_char * memberName);
void TPFuncCall_Array_clear(iTJSDispatch2 * src);
void TPFuncCall_Array_clear(iTJSDispatch2 * src, const tjs_char * memberName);

// X,Y C^[[u
void Array_deinterleaveXY(iTJSDispatch2 * path, tjs_int arraysize, tjs_int * x, tjs_int * y);
void Array_deinterleaveXY(iTJSDispatch2 * path, tjs_int arraysize, tjs_real * x, tjs_real * y);

// Oo
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName);
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName, const ttstr & param1);
void TP_AddLog(const tjs_char * msg, const tjs_char * memberName, const ttstr & param1, const ttstr & param2);

// O[o萔
void TP_AddConstRegisterExpression(ttstr & expression, const ttstr & name, tjs_int value);
void TP_AddConstDeleteExpression(ttstr & expression, const ttstr & name);


// lCeBuNX
#include "tjse_ncdecl.h"

// INebg
tTJSVariantOctet * AllocVariantOctetFromString(ttstr & workstr, tjs_int mode, const tjs_char * __tp_member_name);

// sprintf
tjs_int __cdecl TP_vsprintf(ttstr &result, const tjs_char *format, ...);


/**
 * Windows APĨG[R[hG[bZ[W擾܂B
 * @param err G[R[hB
 * @return G[bZ[WB
 */
ttstr & GetErrorMessageStr(DWORD err);



#endif _TVP_PLUGIN_COMMON_H_
