
#include "ZrvlVariant.h"

//---------------------------------------------------------------------------
// is null?
bool ZrvlIsNullObject(const tTJSVariant * obj)
{
	return ((obj->AsObjectClosureNoAddRef()).Object == NULL);
}
//---------------------------------------------------------------------------
bool ZrvlIsNullObject(const tTJSVariantClosure * obj)
{
	return (obj->Object == NULL);
}
//---------------------------------------------------------------------------
// instanceof Zq
bool ZrvlIsObjectInstanceOf(iTJSDispatch2 * obj, const tjs_char * name)
{
	static tjs_uint32 hint = 0;
	return (obj->IsInstanceOf(0, NULL, &hint, name, obj) == TJS_S_TRUE);
}
//---------------------------------------------------------------------------
bool ZrvlIsObjectInstanceOf(const tTJSVariantClosure * obj, const tjs_char * name)
{
	static tjs_uint32 hint = 0;
	return (obj->IsInstanceOf(0, NULL, &hint, name, NULL) == TJS_S_TRUE);
}
//---------------------------------------------------------------------------
bool ZrvlIsObjectInstanceOf(const tTJSVariant * var, const tjs_char * name)
{
	static tjs_uint32 hint = 0;
	tTJSVariantClosure * obj = &(var->AsObjectClosureNoAddRef());
	return (obj->IsInstanceOf(0, NULL, &hint, name, NULL) == TJS_S_TRUE);
}
//---------------------------------------------------------------------------
tjs_error ZrvlGetClassInstanceInfoArray(tTJSVariant * target, /*result*/tTJSVariant * arrayobj, const tjs_char * callerName)
{
	// void
	if (!target) {
		return TJS_S_OK;
	}

	iTJSDispatch2 * obj = target->AsObjectNoAddRef();
	iTJSDispatch2 * tmpArray = arrayobj->AsObjectNoAddRef();
	tTJSVariant value;
	tjs_int num = 0;
	tjs_error errcode;
	tTJSVariant * val[1] = { NULL };

	// get info.
	do {
		try {
			errcode = obj->ClassInstanceInfo(TJS_CII_GET, num, &value);
		} catch (...) {
			TJSE_THROW(TJSEM_E_NATIVE_FUNC_FAIL, callerName, TJS_W("ClassInstanceInfo"));
		}
		// 擾łȂ_ŏI
		if (errcode == TJS_E_FAIL) break;
		// ςȒlԂĂO
		if (TJS_FAILED(errcode)) {
			TJSE_THROW(TJSEM_E_NATIVE_FUNC_FAIL, callerName, TJS_W("ClassInstanceInfo"));
		}

		try {
			static tTJSVariant result;
			static tjs_uint32 hint = 0;
			val[0] = &value;
			tjs_error errcode = tmpArray->FuncCall(0, TJS_W("add"), &hint, &result, 1, val, tmpArray);
			if (TJS_FAILED(errcode)) {
				TJSE_THROW(TJSEM_E_FUNCCALL_FAIL, callerName, TJS_W("Array.add"));
			}

		} catch (...) {
			throw;
		}

		num++;
	} while (TJS_SUCCEEDED(errcode));

	return errcode;
}
//---------------------------------------------------------------------------
tjs_error ZrvlGetClassInstanceInfo(tTJSVariant * target, /*result*/tTJSVariant * stringobj, const tjs_char * callerName)
{
	// void
	if (!target) {
		return TJS_E_FAIL;
	}

	iTJSDispatch2 * obj = target->AsObjectNoAddRef();
	tTJSVariant value;
	tjs_error errcode;

	try {
		errcode = obj->ClassInstanceInfo(TJS_CII_GET, 0, &value);
	} catch (...) {
		TJSE_THROW(TJSEM_E_NATIVE_FUNC_FAIL, callerName, TJS_W("ClassInstanceInfo"));
	}

	*stringobj = value;

	return errcode;
}

//---------------------------------------------------------------------------
// ^
const ttstr & ZrvlGetVariantTypeName(const tTJSVariant * variant)
{
	return ZrvlGetVariantTypeName(variant->Type());
}
//---------------------------------------------------------------------------
const ttstr & ZrvlGetVariantTypeName(const tTJSVariant & variant)
{
	return ZrvlGetVariantTypeName(variant.Type());
}
//---------------------------------------------------------------------------
const ttstr & ZrvlGetVariantTypeName(tTJSVariantType type)
{
	static const ttstr ST_INT("");
	static const ttstr ST_REAL("");
	static const ttstr ST_STR("");
	static const ttstr ST_OCT("INebg");
	static const ttstr ST_OBJ("IuWFNg");
	static const ttstr ST_VOID("void");
	static const ttstr ST_UNK("s");

	switch (type) {
	case tvtInteger: return ST_INT;
	case tvtReal:    return ST_REAL;
	case tvtString:  return ST_STR;
	case tvtOctet:   return ST_OCT;
	case tvtObject:  return ST_OBJ;
	case tvtVoid:    return ST_VOID;
	default:         return ST_UNK;
	}
}
//---------------------------------------------------------------------------
tZrvlVariantType ZrvlGetVariantType(const tTJSVariant * target)
{
	tZrvlVariantType rc = vtZrvl_undefined;
	if (!target) return rc;

	tTJSVariantType type = target->Type();
	switch (type) {
	case tvtInteger:
		rc = vtZrvl_Integer;
		break;
	case tvtReal:
		rc = vtZrvl_Real;
		break;
	case tvtString:
		rc = vtZrvl_String;
		break;
	case tvtOctet:
		rc = vtZrvl_Octet;
		break;
	case tvtVoid:
		rc = vtZrvl_void;
		break;
	case tvtObject:
		if      (ZrvlIsNullObject(target)) rc = vtZrvl_null;
		else if (ZrvlIsObjectInstanceOf(target, TJS_W("Array"))) rc = vtZrvl_Array;
		else if (ZrvlIsObjectInstanceOf(target, TJS_W("Dictionary"))) rc = vtZrvl_Dictionary;
		else if (ZrvlIsObjectInstanceOf(target, TJS_W("Function"))) rc = vtZrvl_Function;
		else if (ZrvlIsObjectInstanceOf(target, TJS_W("Property"))) rc = vtZrvl_Property;
		else if (ZrvlIsObjectInstanceOf(target, TJS_W("Class"))) rc = vtZrvl_Class;
		else    rc = vtZrvl_Object;
		break;
	default:
		// Ȃɂc
		break;
	}

	return rc;
}
//---------------------------------------------------------------------------
