#ifndef _JULIAN_DAY_H_
#define _JULIAN_DAY_H_

// 
#include "TVPPlugIn.h"


//----------------------------------------------------------------------
#ifndef TJS_W
  #define TJS_W(X) L##X
  typedef wchar_t tjs_char;
  typedef int tjs_int;
  typedef double tjs_real;
  #define JD_REQUIRE_TJS_STRICMP
#endif
//----------------------------------------------------------------------


//----------------------------------------------------------------------
struct jd_TimezoneLookupTable
{
	tjs_char *name;
	tjs_int  type;
	tjs_int  gmtoffset;
	tjs_char *full_tz_name;
};
//----------------------------------------------------------------------
/**
[JUTCEX擾܂B
@param tz ^C][bPʂŎw肵܂B{Ȃ+32400łB
@param y NB
@param m B1`12B
@param d B
@param hh B
@param mi B
@param dd bB
@param time B
@return EXiUTCjB
*/
double jd_GetJulianDay(tjs_int tz, tjs_int y, tjs_int m, tjs_int d, 
	tjs_int hh, tjs_int mi, tjs_real ss);
double jd_GetJulianDay(tjs_int tz, tjs_int y, tjs_int m, tjs_int d, 
	tjs_int hh, tjs_int mi, tjs_real ss, tjs_real &time);
//----------------------------------------------------------------------
/**
UTCEX烍[J擾܂B
@param j UTCEXB
@param tz ^C][bPʂŎw肵܂B{Ȃ+32400łB
@param y Nϐւ̎QƁB
@param m ϐւ̎QƁB1`12B
@param d ϐւ̎QƁB
@param hh ϐւ̎QƁB
@param mi ϐւ̎QƁB
@param dd bϐւ̎QƁB
*/
void jd_GetYMDHMS(tjs_real jd, tjs_int tz, 
	tjs_int &y, tjs_int &m, tjs_int &d, tjs_int &hh, tjs_int &mi, tjs_real &ss);
void jd_GetYMDHMS(tjs_real jd, tjs_real time, tjs_int tz, 
	tjs_int &y, tjs_int &m, tjs_int &d, tjs_int &hh, tjs_int &mi, tjs_real &ss);
//----------------------------------------------------------------------
/**
[Nǂ𔻒肵܂B
@param y N
@return [NȂtrueB
*/
bool jd_IsLeapYear(tjs_int y);
//----------------------------------------------------------------------
/**
^C][擾܂B
*/
const jd_TimezoneLookupTable* jd_SearchTimezone(const tjs_char *word, 
	tjs_int gmtoffset, tjs_int isdst, bool fullname = false);
const jd_TimezoneLookupTable* jd_SearchTimezone(const tjs_char *word, 
	tjs_int isdst, bool fullname = false);
const jd_TimezoneLookupTable* jd_SearchTimezoneFB(const tjs_char *word, 
	tjs_int isdst, bool fullname = false);	// fallback
//----------------------------------------------------------------------
/**
^C][Zktl[擾܂B
*/
const tjs_char *jd_FullZoneNameFromAbbr(const tjs_char *abbr, 
	tjs_int gmtoffset, tjs_int isdst);
//----------------------------------------------------------------------


#endif _JULIAN_DAY_H_
