#include "VariantDumperNI.h"
#include "TPPropGetIF.h"


//---------------------------------------------------------------------------
// lCeBuCX^X VariantDumperNI

//---------------------------------------------------------------------------
void TJSE_NI_CLASS_NAME(VariantDumper)::InitFormatString()
{
	// default values
	ttstr * fs = this->FormatString;
	tValueReplaceType * rt = this->ValueReplaceType;

	fs[fsPreValue_Integer] = TJS_W("int ");
	fs[fsPostValue_Integer] = TJS_W("");
	fs[fsReplaceValue_Integer] = TJS_W("");
	rt[vtZrvl_Integer] = rtReplaceType_None;

	fs[fsPreValue_Real] = TJS_W("real ");
	fs[fsPostValue_Real] = TJS_W("");
	fs[fsReplaceValue_Real] = TJS_W("");
	rt[vtZrvl_Real] = rtReplaceType_None;

	fs[fsPreValue_String] = TJS_W("string \"");
	fs[fsPostValue_String] = TJS_W("\"");
	fs[fsReplaceValue_String] = TJS_W("");
	rt[vtZrvl_String] = rtReplaceType_None;

	fs[fsPreValue_Octet] = TJS_W("<% ");
	fs[fsPostValue_Octet] = TJS_W(" %>");
	fs[fsReplaceValue_Octet] = TJS_W("");
	rt[vtZrvl_Octet] = rtReplaceType_Dump;

	fs[fsPreValue_null] = TJS_W("");
	fs[fsPostValue_null] = TJS_W("");
	fs[fsReplaceValue_null] = TJS_W("(null)");
	rt[vtZrvl_null] = rtReplaceType_String;

	fs[fsPreValue_void] = TJS_W("");
	fs[fsPostValue_void] = TJS_W("");
	fs[fsReplaceValue_void] = TJS_W("(void)");
	rt[vtZrvl_void] = rtReplaceType_String;

	fs[fsPreValue_undefined] = TJS_W("");
	fs[fsPostValue_undefined] = TJS_W("");
	fs[fsReplaceValue_undefined] = TJS_W("(undefined)");
	rt[vtZrvl_undefined] = rtReplaceType_String;

	fs[fsPreValue_Class] = TJS_W("");
	fs[fsPostValue_Class] = TJS_W("");
	fs[fsReplaceValue_Class] = TJS_W("(Class)");
	rt[vtZrvl_Class] = rtReplaceType_String;

	fs[fsPreValue_Function] = TJS_W("");
	fs[fsPostValue_Function] = TJS_W("");
	fs[fsReplaceValue_Function] = TJS_W("(Function)");
	rt[vtZrvl_Function] = rtReplaceType_String;

	fs[fsPreValue_Property] = TJS_W("");
	fs[fsPostValue_Property] = TJS_W("");
	fs[fsReplaceValue_Property] = TJS_W("(Property)");
	rt[vtZrvl_Property] = rtReplaceType_String;

	fs[fsPreValue_Object] = TJS_W("instanceof(");
	fs[fsPostValue_Object] = TJS_W(")");
	fs[fsReplaceValue_Object] = TJS_W("(Object)");
	rt[vtZrvl_Object] = rtReplaceType_Class;

	fs[fsOpen_Array] = TJS_W("[\n");
	fs[fsClose_Array] = TJS_W("]");
	fs[fsPreFirstValue_Array] = TJS_W("");
	fs[fsPreValue_Array] = TJS_W("");
	fs[fsPostValue_Array] = TJS_W(",\n");
	fs[fsPostLastValue_Array] = TJS_W("\n");
	fs[fsReplaceValue_Array] = TJS_W("");
	rt[vtZrvl_Array] = rtReplaceType_None;

	fs[fsOpen_Dictionary] = TJS_W("%[\n");
	fs[fsClose_Dictionary] = TJS_W("]");
	fs[fsPreFirstKey_Dictionary] = TJS_W("\"");
	fs[fsPreKey_Dictionary] = TJS_W("\"");
	fs[fsPostKey_Dictionary] = TJS_W("\" => ");
	fs[fsPreValue_Dictionary] = TJS_W("");
	fs[fsPostValue_Dictionary] = TJS_W(",\n");
	fs[fsPostLastValue_Dictionary] = TJS_W("\n");
	fs[fsReplaceValue_Dictionary] = TJS_W("");
	rt[vtZrvl_Dictionary] = rtReplaceType_None;

	fs[fsIndentBase_Structure] = TJS_W("  ");

	return;
}


/*
OpC^[tF[XB
*/
//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::Dump(tTJSVariant * target, ttstr & result)
{
	BeginDump();
	bool rc = AsString(target, result, 0);
	EndDump();
	return rc;
}

//---------------------------------------------------------------------------
tjs_int TJSE_NI_CLASS_NAME(VariantDumper)::GetMaxDepth()
{
	return MaxDepth;
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::SetMaxDepth(tjs_int depth)
{
	if (depth <= VD_MAX_DEPTH_LIMIT && depth >= 0) {
		MaxDepth = depth;
		return true;
	}
	return false;
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::GetRecurringReference()
{
	return RecurringReference;
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::SetRecurringReference(bool allow)
{
	RecurringReference = allow;
	return true;
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::IsAccessorBypassed()
{
	return AccessorBypass;
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::BypassAccessor(bool ignore)
{
	AccessorBypass = ignore;
	return true;
}

//---------------------------------------------------------------------------
static bool OverrideFS(tTJSVariantClosure * dic, const tjs_char * key, ttstr * fs, tFormatStringIndex fi)
{
	bool rv = false;

	tTJSVariant wkval;
	try {
		tjs_error rc = dic->PropGet(TJS_MEMBERMUSTEXIST, key, NULL, &wkval, NULL);
		if (TJS_SUCCEEDED(rc)) {
			fs[fi] = wkval.GetString();
			rv = true;
		}
	} catch (...) {
		// TODO...?
		throw;
	}
	return rv;
}

//---------------------------------------------------------------------------
static bool OverrideRT(tTJSVariantClosure * dic, const tjs_char * key, tValueReplaceType * rt, tZrvlVariantType vt)
{
	bool rv = false;

	tTJSVariant wkval;
	try {
		tjs_error rc = dic->PropGet(TJS_MEMBERMUSTEXIST, key, NULL, &wkval, NULL);
		if (TJS_SUCCEEDED(rc)) {
			rt[vt] = wkval.AsInteger();
			rv = true;
		}
	} catch (...) {
		// TODO...?
		throw;
	}
	return rv;
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::SetFormatString(tTJSVariantClosure * dic)
{
#define Call_OverrideFS(_wt, _type) OverrideFS(dic, TJS_W(#_wt) TJS_W("_") TJS_W(#_type), this->FormatString, fs##_wt##_##_type)
#define Call_OverrideRT(_type) OverrideRT(dic, TJS_W("ReplaceValueType_") TJS_W(#_type), this->ValueReplaceType, vtZrvl_##_type)

	Call_OverrideFS(PreValue, Integer);
	Call_OverrideFS(PostValue, Integer);
	Call_OverrideFS(ReplaceValue, Integer);
	Call_OverrideFS(PreValue, Real);
	Call_OverrideFS(PostValue, Real);
	Call_OverrideFS(ReplaceValue, Real);
	Call_OverrideFS(PreValue, String);
	Call_OverrideFS(PostValue, String);
	Call_OverrideFS(ReplaceValue, String);
	Call_OverrideFS(PreValue, Octet);
	Call_OverrideFS(PostValue, Octet);
	Call_OverrideFS(ReplaceValue, Octet);
	Call_OverrideFS(PreValue, null);
	Call_OverrideFS(PostValue, null);
	Call_OverrideFS(ReplaceValue, null);
	Call_OverrideFS(PreValue, void);
	Call_OverrideFS(PostValue, void);
	Call_OverrideFS(ReplaceValue, void);
	Call_OverrideFS(PreValue, undefined);
	Call_OverrideFS(PostValue, undefined);
	Call_OverrideFS(ReplaceValue, undefined);
	Call_OverrideFS(PreValue, Class);
	Call_OverrideFS(PostValue, Class);
	Call_OverrideFS(ReplaceValue, Class);
	Call_OverrideFS(PreValue, Function);
	Call_OverrideFS(PostValue, Function);
	Call_OverrideFS(ReplaceValue, Function);
	Call_OverrideFS(PreValue, Property);
	Call_OverrideFS(PostValue, Property);
	Call_OverrideFS(ReplaceValue, Property);
	Call_OverrideFS(PreValue, Object);
	Call_OverrideFS(PostValue, Object);
	Call_OverrideFS(ReplaceValue, Object);
	Call_OverrideFS(PreFirstValue, Array);
	Call_OverrideFS(Open, Array);
	Call_OverrideFS(Close, Array);
	Call_OverrideFS(PreValue, Array);
	Call_OverrideFS(PostValue, Array);
	Call_OverrideFS(PostLastValue, Array);
	Call_OverrideFS(ReplaceValue, Array);
	Call_OverrideFS(Open, Dictionary);
	Call_OverrideFS(Close, Dictionary);
	Call_OverrideFS(PreFirstKey, Dictionary);
	Call_OverrideFS(PreKey, Dictionary);
	Call_OverrideFS(PostKey, Dictionary);
	Call_OverrideFS(PreValue, Dictionary);
	Call_OverrideFS(PostValue, Dictionary);
	Call_OverrideFS(PostLastValue, Dictionary);
	Call_OverrideFS(ReplaceValue, Dictionary);
	Call_OverrideFS(ReplaceValue, Dictionary);
	Call_OverrideFS(IndentBase, Structure);

	Call_OverrideRT(void);
	Call_OverrideRT(null);
	Call_OverrideRT(Integer);
	Call_OverrideRT(Real);
	Call_OverrideRT(String);
	Call_OverrideRT(Octet);
	Call_OverrideRT(Object);
	Call_OverrideRT(Class);
	Call_OverrideRT(Function);
	Call_OverrideRT(Property);
	Call_OverrideRT(Array);
	Call_OverrideRT(Dictionary);
	Call_OverrideRT(undefined);

#undef Call_OverrideFS
#undef Call_OverrideRT

	return true;
}
//---------------------------------------------------------------------------





/*
pC^[tF[XB
*/

//---------------------------------------------------------------------------
void TJSE_NI_CLASS_NAME(VariantDumper)::CreateFuncTable_AsString()
{
#define Call_RegFunc(_type) AsStringFuncTable[vtZrvl_##_type] = &TJSE_NI_CLASS_NAME(VariantDumper)::AsStringFor##_type
	Call_RegFunc(Integer);
	Call_RegFunc(void);
	Call_RegFunc(null);
	Call_RegFunc(Real);
	Call_RegFunc(String);
	Call_RegFunc(undefined);
	Call_RegFunc(Octet);
	Call_RegFunc(Object);
	Call_RegFunc(Class);
	Call_RegFunc(Function);
	Call_RegFunc(Property);
	Call_RegFunc(Array);
	Call_RegFunc(Dictionary);
#undef Call_RegFunc
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::AsString(tTJSVariant * target, ttstr & result, tjs_int depth)
{
	bool rc = false;

	tZrvlVariantType vt = ZrvlGetVariantType(target);
	rc = (this->*(AsStringFuncTable[vt]))(target, result, depth + 1);

	return rc;
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::InternalAsString(
	tTJSVariant * target, ttstr & result, tZrvlVariantType vt, 
	tFormatStringIndex preValue, tFormatStringIndex postValue, tFormatStringIndex repValue)
{
	bool rc = true;
	ttstr * fs = FormatString;
	tValueReplaceType rt = ValueReplaceType[vt];

	switch (rt) {
	case rtReplaceType_String:
		result = fs[preValue] + fs[repValue] + fs[postValue];
		break;
	case rtReplaceType_ToString:
		break;
	case rtReplaceType_Classes:
	case rtReplaceType_Class:
	{
		tTJSVariant tmp;
		tjs_error errcode = ZrvlGetClassInstanceInfo(target, &tmp, TJSEM_ANON_FUNC);
		if (TJS_SUCCEEDED(errcode)) {
			result = fs[preValue] + tmp.GetString() + fs[postValue];
		} else {
			result = fs[repValue];
		}
	}
		break;
	case rtReplaceType_Dump:
		break;
	case rtReplaceType_None:
	default:
		result = fs[preValue] + (*target) + fs[postValue];
		break;
	}


	return rc;
}

//---------------------------------------------------------------------------
static void RepeatString(const ttstr & base, tjs_int count, ttstr & result)
{
	result.Clear();
	for (tjs_int i = 0; i < count; i++) {
		result += base;
	}
}

//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::AsStringForArray(tTJSVariant * target, ttstr & result, tjs_int depth)
{
	if (depth > MaxDepth) {
		AsStringForObject(target, result, depth);
		return false;
	}

	bool rc = true;
	ttstr * fs = FormatString;

	iTJSDispatch2 * array = target->AsObjectNoAddRef();
	tjs_int count = TPPropGet_Array_count(array);
	tjs_int lastIndex = count - 1;
	ttstr indent;
	RepeatString(fs[fsIndentBase_Structure], depth, indent);

	result = fs[fsOpen_Array];

	{
		const tFormatStringIndex
			preFValue = fsPreFirstValue_Array,
			preValue = fsPreValue_Array,
			postValue = fsPostValue_Array,
			postLValue = fsPostLastValue_Array;

		const bool ignoreProp = this->AccessorBypass;

		for (tjs_int i = 0; i < count; i++) {
			tTJSVariant val = TPPropGetByNum_Array_AsVariant(array, i, ignoreProp);
			ttstr tmp;
			AsString(&val, tmp, depth);

			result += indent;
			result += fs[(i == 0) ? preFValue : preValue];
			result += tmp;
			result += fs[(i == lastIndex) ? postLValue : postValue];
		}
	}

	// fs[fsClose_Array]󕶎̏ꍇ̓CfgȂB
	if (fs[fsClose_Array].GetLen() > 0) {
		RepeatString(fs[fsIndentBase_Structure], depth - 1, indent);
		result += indent + fs[fsClose_Array];
	}

	return rc;
}
//---------------------------------------------------------------------------
bool TJSE_NI_CLASS_NAME(VariantDumper)::AsStringForDictionary(tTJSVariant * target, ttstr & result, tjs_int depth)
{
	if (depth > MaxDepth) {
		AsStringForObject(target, result, depth);
		return false;
	}

	bool rc = true;
	ttstr * fs = FormatString;

	iTJSDispatch2 * dic = target->AsObjectNoAddRef();
	iTJSDispatch2 * array = TJSCreateArrayObject();
	tjs_int count = 0;

	try {
		TPFuncCall_Array_assign(dic, array);
		count = TPPropGet_Array_count(array);
	} catch (...) {
		array->Release();
		throw;
	}

	if (count % 2) count--;

	tjs_int lastIndex = count - 2;
	ttstr indent;
	RepeatString(fs[fsIndentBase_Structure], depth, indent);

	result = fs[fsOpen_Dictionary];

	try {
		const tFormatStringIndex
			preFKey = fsPreFirstKey_Dictionary,
			preKey = fsPreKey_Dictionary,
			postKey = fsPostKey_Dictionary,
			preValue = fsPreValue_Dictionary,
			postValue = fsPostValue_Dictionary,
			postLValue = fsPostLastValue_Dictionary;

		const bool ignoreProp = this->AccessorBypass;

		for (tjs_int i = 0; i < count; i += 2) {
			tTJSVariant key = TPPropGetByNum_Array_AsVariant(array, i, ignoreProp);
			tTJSVariant val = TPPropGetByNum_Array_AsVariant(array, i + 1, ignoreProp);
			ttstr tmp;
			AsString(&val, tmp, depth);

			result += indent;
			result += fs[(i == 0) ? preFKey : preKey];
			result += key + fs[postKey] + fs[preValue] + tmp;
			result += fs[(i == lastIndex) ? postLValue : postValue];
		}
	} catch (...) {
		array->Release();
		throw;
	}
	array->Release();

	// fs[fsClose_Dictionary]󕶎̏ꍇ̓CfgȂB
	if (fs[fsClose_Dictionary].GetLen() > 0) {
		RepeatString(fs[fsIndentBase_Structure], depth - 1, indent);
		result += indent + fs[fsClose_Dictionary];
	}

	return rc;
}


//---------------------------------------------------------------------------
void TJSE_NI_CLASS_NAME(VariantDumper)::BeginDump()
{
	return;
}

//---------------------------------------------------------------------------
void TJSE_NI_CLASS_NAME(VariantDumper)::EndDump()
{
	return;
}

//---------------------------------------------------------------------------

