#ifndef _VariantDumperNI_H_
#define _VariantDumperNI_H_
//--------------------------------------------------------------
// ϐ_v
//--------------------------------------------------------------

#include "TVPPlugin.h"
#include <map>;

/*
tH[}bgw莫z̏F
key ::= formatkey|commonkey
formatkey ::= Pre|Post|PreFirst|PostLast|Replace|Open|Close + [ Key|Value ] + "_" + TYPE
commonkey ::= IndentBase
TYPE ::= Integer|Real|String|Octet|null|void|undefined|Class|Function|Property|Array|Dictionary|Object
value ::= \

key'Key'gpł̂Dictionarŷ݁B
key'PreFirst', 'PostLast'wł̂ArrayDictionarŷ

%[
'PreFirstValue_Array' => "[\n",
'PreValue_String' => '"',
'PostValue_String' => '"',
'IndentBase' => '  '
]

*/


enum tValueReplaceType {
	rtReplaceType_None,
	rtReplaceType_String,	// ReplaceValue_xxx
	rtReplaceType_ToString,	// target.toString()
	rtReplaceType_Class,	// ClassInstanceInfo[0]
	rtReplaceType_Classes,	// ClassInstanceInfo.join(",")
	rtReplaceType_Dump,	// default dump
	rtReplaceType_Dummy_Last
};

enum tFormatStringIndex {
	fsPreValue_Integer = 0,
	fsPostValue_Integer,
	fsReplaceValue_Integer,
	fsPreValue_Real,
	fsPostValue_Real,
	fsReplaceValue_Real,
	fsPreValue_String,
	fsPostValue_String,
	fsReplaceValue_String,
	fsPreValue_Octet,
	fsPostValue_Octet,
	fsReplaceValue_Octet,
	fsPreValue_null,
	fsPostValue_null,
	fsReplaceValue_null,
	fsPreValue_void,
	fsPostValue_void,
	fsReplaceValue_void,
	fsPreValue_undefined,
	fsPostValue_undefined,
	fsReplaceValue_undefined,
	fsPreValue_Class,
	fsPostValue_Class,
	fsReplaceValue_Class,
	fsPreValue_Function,
	fsPostValue_Function,
	fsReplaceValue_Function,
	fsPreValue_Property,
	fsPostValue_Property,
	fsReplaceValue_Property,
	fsPreValue_Object,
	fsPostValue_Object,
	fsReplaceValue_Object,
	fsPreFirstValue_Array,
	fsOpen_Array,
	fsClose_Array,
	fsPreValue_Array,
	fsPostValue_Array,
	fsPostLastValue_Array,
	fsReplaceValue_Array,
	fsOpen_Dictionary,
	fsClose_Dictionary,
	fsPreFirstKey_Dictionary,
	fsPreKey_Dictionary,
	fsPostKey_Dictionary,
	fsPreValue_Dictionary,
	fsPostValue_Dictionary,
	fsPostLastValue_Dictionary,
	fsReplaceValue_Dictionary,
	fsIndentBase_Structure,
	fsFormatStringIndex_Dummy_Last
};

const tjs_int tValueReplaceType_Size = rtReplaceType_Dummy_Last;
const tjs_int tVariantType_Size = vtZrvl_Dummy_Last;
const tjs_int tFormatStringIndex_Size = fsFormatStringIndex_Dummy_Last;


//---------------------------------------------------------------------------
// lCeBuCX^X
TJSE_NATIVE_INSTANCE_DECL_BEGIN(VariantDumper)
protected:
	tValueReplaceType ValueReplaceType[tVariantType_Size];	// u^
	ttstr FormatString[tFormatStringIndex_Size];	// tH[}bg
	tjs_int MaxDepth;	// őċA[x
	bool RecurringReference;	// zQƂ
	bool AccessorBypass;	// vpeBANZToCpX邩

// ݒElB
// ĕςȒlݒ肵Ă܂AߎSȏԂɂȂ̂hB
#define VD_MAX_DEPTH_LIMIT (32)

public:
	// C++ RXgN^
	TJSE_NI_CONSTRUCTOR(VariantDumper) :
		MaxDepth(8),
		AccessorBypass(false),
		RecurringReference(true)
	{
	}

	// C++fXgN^
	TJSE_NI_DESTRUCTOR(VariantDumper)
	{
	}

	// TJS RXgN^
	TJSE_TJS_CONSTRUCTOR_DECL
	{
		InitFormatString();
		CreateFuncTable_AsString();
		return S_OK;
	}

	// TJS fXgN^
	void TJS_INTF_METHOD Invalidate()
	{
	}

	virtual void InitFormatString();

public:

	/***
	OpC^[tF[XB
	*/
	virtual bool Dump(tTJSVariant * target, ttstr & result);
	tjs_int GetMaxDepth();
	bool SetMaxDepth(tjs_int depth);
	bool GetRecurringReference(void);
	bool SetRecurringReference(bool allow);
	bool IsAccessorBypassed(void);
	bool BypassAccessor(bool bypass);
	bool SetFormatString(tTJSVariantClosure * dic);

protected:
	typedef bool (TJSE_NI_CLASS_NAME(VariantDumper)::*AsStringFunc_t)(tTJSVariant * target, ttstr & result, tjs_int depth);
	AsStringFunc_t AsStringFuncTable[tVariantType_Size];

	void CreateFuncTable_AsString();

	/***
	pC^[tF[XB
	*/
	bool AsString(tTJSVariant * target, ttstr & result, tjs_int depth);

	bool InternalAsString(tTJSVariant * target, ttstr & result, tZrvlVariantType vt, 
		tFormatStringIndex preValue, tFormatStringIndex postValue, tFormatStringIndex repValue);

#define DefFunc_AsStringFor(_type) \
	bool AsStringFor##_type(tTJSVariant * target, ttstr & result, tjs_int depth) \
	{ \
		bool rc = InternalAsString(target, result, \
			vtZrvl_##_type, fsPreValue_##_type, fsPostValue_##_type, fsReplaceValue_##_type); \
		return rc; \
	}

	DefFunc_AsStringFor(Integer)
	DefFunc_AsStringFor(Real)
	DefFunc_AsStringFor(String)
	DefFunc_AsStringFor(Octet)
	DefFunc_AsStringFor(null)
	DefFunc_AsStringFor(void)
	DefFunc_AsStringFor(undefined)
	DefFunc_AsStringFor(Object)
	DefFunc_AsStringFor(Class)
	DefFunc_AsStringFor(Function)
	DefFunc_AsStringFor(Property)

#undef Call_InternalAsString
#undef DefFunc_AsStringFor

	bool AsStringForArray(tTJSVariant * target, ttstr & result, tjs_int depth);
	bool AsStringForDictionary(tTJSVariant * target, ttstr & result, tjs_int depth);

	/***
	֐̐LqĂB
	
	*/
	virtual void BeginDump();

	/***
	֐̐LqĂB
	
	*/
	virtual void EndDump();

TJSE_NATIVE_INSTANCE_DECL_END
//---------------------------------------------------------------------------


//--------------------------------------------------------------
#endif  _VariantDumperNI_H_
