
#include "TVPPlugIn.h"
#include "KRLayerIntf.h"


//------------------------------------------------------------------------------
// function Layer.update
//------------------------------------------------------------------------------
void TPFuncCall_Layer_update(iTJSDispatch2 * layer, const tjs_char * memberName) {
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	TP_ITJSDISPATCH2_FUNCCALL(layer, Layer, update, &hint, &result, 0, NULL, memberName)
	return;
}

void TPFuncCall_Layer_update(iTJSDispatch2 * layer) {
	TPFuncCall_Layer_update(layer, TJSEM_ANON_FUNC);
}



//------------------------------------------------------------------------------
// extra property Layer.clipRect
//------------------------------------------------------------------------------
const tjs_int TPPropGetEx_Layer_clipRect(iTJSDispatch2 * layer, tTVPRect * dest, const tjs_char * memberName) {
	static tjs_uint32 hint_left   = 0;
	static tjs_uint32 hint_top    = 0;
	static tjs_uint32 hint_width  = 0;
	static tjs_uint32 hint_height = 0;

	tTJSVariant workVal;

	TP_ITJSDISPATCH2_PROPGET(layer, Layer, clipLeft, &hint_left, &workVal, memberName)
	dest->left = workVal;

	TP_ITJSDISPATCH2_PROPGET(layer, Layer, clipTop, &hint_top, &workVal, memberName)
	dest->top  = workVal;

	TP_ITJSDISPATCH2_PROPGET(layer, Layer, clipWidth, &hint_width, &workVal, memberName)
	dest->set_width((tjs_int)workVal - 1);

	TP_ITJSDISPATCH2_PROPGET(layer, Layer, clipHeight, &hint_height, &workVal, memberName)
	dest->set_height((tjs_int)workVal - 1);

	return 1;
}

const tjs_int TPPropGetEx_Layer_clipRect(iTJSDispatch2 * layer, tTVPRect * dest) {
	return TPPropGetEx_Layer_clipRect(layer, dest, TJSEM_ANON_FUNC);
}


//------------------------------------------------------------------------------
// function Layer.update (useful)
//------------------------------------------------------------------------------
void TPFuncCall_Layer_update(LayerInfo * info, tjs_int x, tjs_int y, tjs_int w, tjs_int h, const tjs_char * memberName) {
	static tTJSVariant result;
	static tjs_uint32 hint = 0;
	static tTJSVariant val[4] = {(tjs_int64)0, (tjs_int64)0, (tjs_int64)0, (tjs_int64)0};

	val[0] = (tjs_int64)x;
	val[1] = (tjs_int64)y;
	val[2] = (tjs_int64)w;
	val[3] = (tjs_int64)h;

	tTJSVariant *pval[4] = {val, val+1, val+2, val+3};
	iTJSDispatch2 * layer = info->dispatcher;

	TP_ITJSDISPATCH2_FUNCCALL(layer, Layer, update, &hint, &result, 4, pval, memberName)
	return;
}

void TPFuncCall_Layer_update(LayerInfo * info, tjs_int x, tjs_int y, tjs_int w, tjs_int h) {
	TPFuncCall_Layer_update(info, x, y, w, h, TJSEM_ANON_FUNC);
}

void TPFuncCall_Layer_update(LayerInfo * info) {
	TPFuncCall_Layer_update(info->dispatcher, TJSEM_ANON_FUNC);
}


//------------------------------------------------------------------------------
// function Layer.colorRect
//------------------------------------------------------------------------------
void TPFuncCall_Layer_colorRect(iTJSDispatch2 * layer, tjs_int numparams, tTJSVariant **params, const tjs_char * memberName) {
	static tTJSVariant result;
	static tjs_uint32 hint = 0;

	TP_ITJSDISPATCH2_FUNCCALL(layer, Layer, colorRect, &hint, &result, numparams, params, memberName)
	return;
}

void TPFuncCall_Layer_colorRect(iTJSDispatch2 * layer, tjs_int numparams, tTJSVariant **params) {
	TPFuncCall_Layer_colorRect(layer, numparams, params, TJSEM_ANON_FUNC);
}
