#ifndef _TVP_PLUGIN_LAYER_INTERFACE_H_
#define _TVP_PLUGIN_LAYER_INTERFACE_H_

#include "TVPPlugIn.h"
#include "TPPropGetIF.h"
#include "ComplexRect.h"

// Ǝg
const tjs_int TPPropGetEx_Layer_clipRect(iTJSDispatch2 * layer, tTVPRect * dest, const tjs_char * memberName);
const tjs_int TPPropGetEx_Layer_clipRect(iTJSDispatch2 * layer, tTVPRect * dest);

// function Layer.update
void Layer_FuncCall_update(iTJSDispatch2 * layer, const tjs_char * memberName);
void Layer_FuncCall_update(iTJSDispatch2 * layer);

// function Layer.colorRect
void Layer_FuncCall_colorRect(iTJSDispatch2 * layer, tjs_int numparams, tTJSVariant **params, const tjs_char * memberName);
void Layer_FuncCall_colorRect(iTJSDispatch2 * layer, tjs_int numparams, tTJSVariant **params);



// gg̃C[Wobt@
// قƂǍ\̈
class ImageBufferInfo
{
public:
	tjs_int width;	// image buffer width
	tjs_int height;	// image buffer height

	const tjs_uint8 * bufferptr;	// image buffer ptr
	tjs_int bufferpitch;	// image buffer pitch in byte

public:
	// RXgN^
	ImageBufferInfo()
	{
		width = height = 0;
		bufferpitch = 0;
		bufferptr = NULL;
	}

	// w肵p[^ŏ
	inline virtual void init(const tjs_uint8 * ptr, tjs_int pitch, tjs_int w, tjs_int h)
	{
		this->bufferptr = ptr;
		this->bufferpitch = pitch;
		this->width = w;
		this->height = h;
		return;
	}

	// w肵Ww|C^
	inline tjs_uint32 * getBufferPtr(tjs_int x, tjs_int y) const
	{
		return (tjs_uint32 *)(this->bufferptr + y * this->bufferpitch + x * sizeof(tjs_uint32));
	}

};


// C
// قƂǍ\̈
class LayerInfo : public ImageBufferInfo
{
public:
	tTVPLayerType type;
	tTVPDrawFace face;
	iTJSDispatch2 * dispatcher;
	tTVPRect * clipRect;
	tTVPRect * drawRect;
	bool holdAlpha;

	// province image
	const tjs_uint8 * bufferptrPv;
	tjs_int bufferpitchPv;	// in byte

public:
	LayerInfo() : ImageBufferInfo()
	{
		clipRect = new tTVPRect();
		drawRect = new tTVPRect();
		holdAlpha = true;
	}

	virtual ~LayerInfo()
	{
		delete clipRect;
		delete drawRect;
	}

	// main image
	// ǂݍݐp
	virtual void setForRead(iTJSDispatch2 * layer)
	{
		setCommon(layer);
		bufferptr = TPPropGet_Layer_mainImageBuffer(layer, false);
		bufferpitch = TPPropGet_Layer_mainImageBufferPitch(layer, false);
	}
	// ݗp
	virtual void setForWrite(iTJSDispatch2 * layer)
	{
		setCommon(layer);
		bufferptr = TPPropGet_Layer_mainImageBufferForWrite(layer, false);
		bufferpitch = TPPropGet_Layer_mainImageBufferPitch(layer, false);
	}

	// province image
	// ǂݍݐp
	virtual void setForReadPv(iTJSDispatch2 * layer)
	{
		setCommon(layer);
		bufferptrPv = TPPropGet_Layer_provinceImageBuffer(layer, false);
		bufferpitchPv = TPPropGet_Layer_provinceImageBufferPitch(layer, false);
	}
	// ݗp
	virtual void setForWritePv(iTJSDispatch2 * layer)
	{
		setCommon(layer);
		bufferptrPv = TPPropGet_Layer_provinceImageBufferForWrite(layer, false);
		bufferpitchPv = TPPropGet_Layer_provinceImageBufferPitch(layer, false);
	}

	virtual void setCommon(iTJSDispatch2 * layer)
	{
		dispatcher = layer;
		face   = TPPropGet_Layer_face(layer, false);
		type   = TPPropGet_Layer_type(layer, false);

		width  = TPPropGet_Layer_imageWidth(layer, false);
		height = TPPropGet_Layer_imageHeight(layer, false);

		holdAlpha = TPPropGet_Layer_holdAlpha(layer, false);

		TPPropGetEx_Layer_clipRect(layer, clipRect);

		drawRect->left = (clipRect->left < 0) ? 0 : clipRect->left;
		drawRect->top  = (clipRect->top  < 0) ? 0 : clipRect->top;
		drawRect->right  = (clipRect->right  >= width)  ? (width - 1)  : clipRect->right;
		drawRect->bottom = (clipRect->bottom >= height) ? (height - 1) : clipRect->bottom;
	}


	inline virtual bool isDrawRegion(tjs_int x, tjs_int y) const
	{
		const tTVPRect * const draw = this->drawRect;
		return ((x >= draw->left) && (y >= draw->top) && (x <= draw->right) && (y <= draw->bottom));
	}

	inline tjs_uint32 * getBufferPtr_StrictDraw(tjs_int x, tjs_int y) const
	{
		tjs_uint32 * p = NULL;
		if (this->isDrawRegion(x, y)) {
			p = this->getBufferPtr(x, y);
		}
		return p;
	}
};


void TPFuncCall_Layer_update(LayerInfo * info, tjs_int x, tjs_int y, tjs_int w, tjs_int h, const tjs_char * memberName);
void TPFuncCall_Layer_update(LayerInfo * info, tjs_int x, tjs_int y, tjs_int w, tjs_int h);
void TPFuncCall_Layer_update(LayerInfo * info);


#endif _TVP_PLUGIN_LAYER_INTERFACE_H_

