
#ifndef _TVP_PLUGIN_MORPH_H_
#define _TVP_PLUGIN_MORPH_H_

//#include "TVPPlugIn.h"
#include "Delaunay.h"
#include "KRLayerIntf.h"


// Op`
#define TRIANGULATE_MODE_DELAUNEY 1

struct TPMorphPointsInfo {
	const tjs_real * x1;
	const tjs_real * y1;
	const tjs_real * x2;
	const tjs_real * y2;
	tjs_int num;
};

struct TPTrianglePos {
public:
	int sx[3], sy[3];	// f[^isigned 16rbgŒ菬_j
	int ux[3], uy[3];	// \[gisigned 16rbgŒ菬_j
	unsigned int order[3];	// _̃\[g

	// _ sp ` ep Ԃ̍W߂
	// ratio : 䗦isigned 16rbgŒ菬_j
	// x, y : Wisigned 16rbgŒ菬_j
	void getPosOnEdge(unsigned int sp, unsigned int ep, int ratio, int& x, int& y) const;

	TPTrianglePos();

	TPTrianglePos(TPTriangle * tri);

	TPTrianglePos(double x0, double y0, double x1, double y1, double x2, double y2);

	void set(double x0, double y0, double x1, double y1, double x2, double y2);

	// sx -> ux
	// sy -> uy
	void copy();

	// reforderɏ]Ē_\[g
	bool orderBy(const TPTrianglePos * ref);

	// w肵Ƃɒ_\[g
	bool orderBy(unsigned int a0, unsigned int a1, unsigned int a2);

	// YWŏɒ_\[g
	void orderByY();

	// O_rectɊSɓĂtrue
	bool isContentOf(const tTVPRect * rect) const;

	// O_Rect(0,0,width,height)ɊSɓĂtrue
	bool isContentOf(tjs_int width, tjs_int height) const;

};




// [sO
tjs_int TPFUNCCALL TPExecuteMorphWarpImpl(
	const ImageBufferInfo * destInfo,
	const ImageBufferInfo * src1Info,
	const ImageBufferInfo * src2Info,
	TPTrianglePos * destTri,
	TPTrianglePos * src1Tri,
	tjs_real morphRatio);

// Op`Rό`
tjs_int TPFUNCCALL TPExecuteMorphTriangleImpl(
	const ImageBufferInfo * destInfo,
	const ImageBufferInfo * src1Info,
	TPTrianglePos * destTri,
	TPTrianglePos * src1Tri,
	TPTrianglePos * src2Tri,
	tjs_real morphRatio);


// O
tjs_int TPFUNCCALL TPExecuteMorphIntf(
	const ImageBufferInfo * destInfo,
	const ImageBufferInfo * src1Info,
	const ImageBufferInfo * src2Info,
	const TPMorphPointsInfo * points,
	tjs_real morphRatio);

tjs_int TPFUNCCALL TPExecuteMorphIntf(
	const TPDelaunay * triangulator,
	const ImageBufferInfo * destInfo,
	const ImageBufferInfo * src1Info,
	const ImageBufferInfo * src2Info,
	const TPMorphPointsInfo * points,
	tjs_real morphRatio);


#endif _TVP_PLUGIN_MORPH_H_

