#ifndef _SharedMemoryNI_H_
#define _SharedMemoryNI_H_
//--------------------------------------------------------------
// 
//--------------------------------------------------------------

#include "TVPPlugIn.h"


//---------------------------------------------------------------------------
// lCeBuCX^X SharedMemory
//---------------------------------------------------------------------------
TJSE_NATIVE_INSTANCE_DECL_BEGIN(SharedMemory)
protected:
	HANDLE hMappingObject;
	tjs_uint32 MappedSize;
	ttstr ObjectName;

	LPCVOID BaseAddress;
	tjs_uint32 AccessMode;

	DWORD LastErrorCode;

public:
	bool IsAllocated() const { return (hMappingObject != 0); }
	bool IsAttached()  const { return (BaseAddress != 0); }
	const ttstr & GetName() const { return ObjectName; }
	tjs_uint32 GetSize() const { return MappedSize; }

	DWORD GetLastErrorCode() const { return LastErrorCode; }


protected:
	void InternalInitGet();
	void InternalInitAtt();
	void InternalRelease();

public:

	// C++ RXgN^
	TJSE_NI_CONSTRUCTOR(SharedMemory);

	// C++fXgN^
	TJSE_NI_DESTRUCTOR(SharedMemory);

	// TJS RXgN^
	TJSE_TJS_CONSTRUCTOR_DECL
	{
		return S_OK;
	}

	// TJS fXgN^
	void TJS_INTF_METHOD Invalidate()
	{
		Free();
	}

	// CreateFileMappingA
	tjs_error Get(const ttstr & key, tTVInteger size);
	// MapViewOfFile
	tjs_error Attach(tjs_uint32 access);
	// UnmapViewOfFile
	tjs_error Detach();
	// CloseHandle
	tjs_error Free();

	// INebg̓ǂݏ
	tjs_error Peek(tTVInteger offset, tTVInteger size, tTJSVariantOctet * & data) const;
	tjs_error Poke(tTVInteger offset, tTVInteger size, const tTJSVariantOctet * data) const;

	// 32rbg̓ǂݏ
	tjs_error Peek32(tTVInteger offset, tjs_uint32 & data) const;
	tjs_error Poke32(tTVInteger offset, tjs_uint32 data) const;

TJSE_NATIVE_INSTANCE_DECL_END



//--------------------------------------------------------------
#endif  _SharedMemoryNI_H_

